;UPOZORNENI
;==================================================================
;TENTO PROGRAM JE AUTORSKY CHRANEN JEHO TVURCEM A JAKEKOLIV ZMENY
;V PROGRAMU SE NEDOPORUCUJI Z DUVODU BEZPECNOSTI CELEHO ZARIZENI.
;PROGRAM JE VLASTNICTVIM SVEHO TVURCE
;================================================================== 
;TIMER1----TI3
;MODELARSKE SERVO HY-S09
;CITLIVOST 1,5 STUPNE  NA 1KROK VULE V PREVODECH PRI ZMENE SMERU CCA 3KROKY
;STRED SERVA M40H = 040H 64 DEK
;KRYSTAL 10MHz VZHLEDEM K SRAM A TYPU SERVA
;KRYSTAL 10MHz  SRAM AT24C128 nebo AT24C32 + VAROVANI  !!!!!!!

$MOD52
		

;-----------------------------------ZAPOJENI RELE -------------------------
	RELE		EQU		P2.0		;RIZENI SERVA.........P2.0	/KIT	P3.2/2051

	LQD		EQU		P0		;PORT DISPLEJE........P0	/KIT	P1/2051

	DPA		EQU		P0.1		;DISPLEJ..............P0.1	/KIT	P1.6/2051
	DPB		EQU		P0.0		;DISPLEJ..............P0.0	/KIT	P1.7/2051
	DPC		EQU		P0.5		;DISPLEJ..............P0.5	/KIT	P1.2/2051

	DPD		EQU		P0.7		;DISPLEJ..............P0.7	/KIT	P1.0/2051
	DPE		EQU		P0.6		;DISPLEJ..............P0.6	/KIT	P1.1/2051
	DPF		EQU		P0.2		;DISPLEJ..............P0.2	/KIT	P1.5/2051
	DPG		EQU		P0.4		;DISPLEJ..............P0.4	/KIT	P1.3/2051

	DOBA_AKCE	EQU 		050H		;PRO RYCHLY PREJEZD---DOBA PUSOBENI MOTORU
	DOBA_KROKU	EQU		010H		;PRO KROKOVANI -------DOBA PUSOBENI MOTORU V KROKU 020H DRIVE

	NEXT		EQU		P2.7		;TLACITKO............P2.7	/KIT	P3.3/2051
	DOLU		EQU		P2.4		;TLACITKO............P2.4	/KIT	P3.4/2051
	NAHORU	EQU		P2.1		;TLACITKO............P2.1	/KIT	P3.5/2051

;==========================================AT 24C128 ========================================================================


FADDR			EQU	0a0h		; fixed address for AT24Cxx EEPROMs
PADDR			EQU	0		; programmable address (0..7)
SIZE			EQU	1000h		; bytes per AT24C64>>2000[8191DEK X 8BITU ]	AT24C128 4000[16384DEK X 8BITU ]	AT24C128 S VYUZITIM 400H <>1024 X 8 BITU
PSIZE			EQU	32		; bytes per page for AT24C64.....32DEK....20H
FILL			EQU	55h		; example fill value

; Register definitions.

index			EQU	r0		; buffer pointer
kount			EQU	r1		; byte count register
zdata			EQU	r1		; data register
addr_lo		EQU	r2		; 2-byte address register
addr_hi		EQU	r3		;

;==========================================AT 24C128 =================================================

; Microcontroller connections to AT24Cxx serial bus lines.

SCL		BIT	P1.1		; serial clock..................P1.1	/KIT	P3.0/2051
SDA		BIT	P1.3		; serial data...................P1.3	/KIT	P3.1/2051
;WP		SPOJENO NA ZEM TRVALE		

;--------------SRAM---------------------------
;	0010H		DATA PRO POLOHU L
;	0020H		DATA PRO POLOHU H
;	0030H		DATA PRO CASOVANI T
;	0040H		DATA PRO CODE1
;	0050H		DATA PRO CODE2
;	0060H		DATA PRO CODE3
;	0070H		DATA PRO CODE4
;	0080H		DATA PRO CODE5
;	0090H		DATA PRO SUMA CODE

;-------------------------VNITRNI PROMENE AT89-RAM-----------------------
;	040H		UDAJ O POLOZE SERVA  = ZADANA POLOHA PRO LCALL POLOHA
;	042H		UDAJ PRO CASOVANI
;	050H		POCET CYKLU NA CEKANI LOCATE

;============================================HLAVNI PROGRAM===========================================

		ORG	0040H		; begin code space


;----------------------------------------HLAVNI PROGRAM------------------------------------------
		;LJMP VAROVANI;============================================================================================		LJMP VAROVANI

		MOV RELE,#0FFH			;VSTUP RELE
		MOV LQD,#0FFH			; DISPLEJ PORT

		CLR RELE
		JNB NEXT,PARAMETR			;TEST TLACITKA NEXT		
;------------------------------CASOVANI-----------------------------------------
		MOV addr_lo,#030H		;CTENI DATA 	
		MOV addr_hi,#000H
		MOV A,#000H
		LCALL read_random
		MOV 042H,A

		JZ  CAS2			;IF A=00

CAS1:		LCALL T05S
		DJNZ 042H,CAS1
CAS2:		

		LCALL TISKL
		MOV addr_lo,#010H		;CTENI DATA 	
		MOV addr_hi,#000H
		MOV A,#000H
		LCALL read_random
		MOV 040H,A
		LCALL POLOHA

		LCALL STOPP

		JMP $

;----------------------------------KONEC FUNKCNIHO PROGRAMU------------------------
;----------------------------UZAMKNUTI--------------------------------------------
PARAMETR:
		LJMP LOCATE
		
;--------------------------PROGRAMOVANI POLOHY L-----------------------------
LLL:		;LJMP VAROVANI;==================================================================================		LJMP VAROVANI
		LCALL TISKL	
		LCALL STRED

H14:	
		LCAll TISKNC
		LCALL T1S	
		LCAll TISKL
		LCALL T1S	


		JB NEXT,H12			;TEST TLACITKA NEXT
		LJMP H15

H12:		JB DOLU,H13			;TEST TLACITKA DOLU
		LCALL KRL
		MOV addr_lo,#010H		;WRITE DATA M40
		MOV addr_hi,#000H
		MOV ZDATA,040H	
		MOV A,#000H
		LCALL write_byte
		LCALL mikroS

		LJMP H14

H13:		JB NAHORU,H14		;TEST TLACITKA NAHORU
		LCALL KRR
		MOV addr_lo,#010H		;WRITE DATA M40 
		MOV addr_hi,#000H
		MOV ZDATA,040H	
		MOV A,#000H
		LCALL write_byte
		LCALL mikroS

		LJMP H14

;--------------------------PROGRAMOVANI POLOHY H-----------------------------

H15:		;LJMP VAROVANI;=================================================================================		LJMP VAROVANI
		LCALL TISKH		
		LCALL STRED

H24:		
		LCAll TISKNC
		LCALL T1S	
		LCAll TISKH
		LCALL T1S	

		JB NEXT,H22			;TEST TLACITKA NEXT
		LJMP H25

H22:		JB DOLU,H23			;TEST TLACITKA DOLU
		LCALL KRL
		MOV addr_lo,#020H		;WRITE DATA M40
		MOV addr_hi,#000H
		MOV ZDATA,040H	
		MOV A,#000H
		LCALL write_byte
		LCALL mikroS

		LJMP H24

H23:		JB NAHORU,H24		;TEST TLACITKA NAHORU
		LCALL KRR
		MOV addr_lo,#020H		;WRITE DATA M40 
		MOV addr_hi,#000H
		MOV ZDATA,040H	
		MOV A,#000H
		LCALL write_byte
		LCALL mikroS

		LJMP H24	

;--------------------------PROGRAMOVANI POLOHY T-----------0 0.5 1 1,5 2 2,5 .......6 /SEC/ 12-13 KROKU

H25:		LCALL TISKT	
		LCALL T1S
		LCALL T1S

		MOV 042H,#000H
		CALL PREVOD

		MOV addr_lo,#030H		;WRITE DATA M42
		MOV addr_hi,#000H
		MOV ZDATA,042H	
		MOV A,#000H
		LCALL write_byte
		LCALL mikroS


H34:		MOV addr_lo,#030H		;CTENI DATA 	
		MOV addr_hi,#000H
		MOV A,#000H
		LCALL read_random
		MOV 042H,A
		CALL PREVOD
		LCALL T1S
		LCALL T1S
		LCALL T1S		

		LCALL TISKT	
		LCALL T1S
		LCALL T1S
		LCALL T1S

		JB NEXT,H32			;NEXT=END PROGRAMOVANI
		LJMP HOTOVO

H32:		JB DOLU,H33			;
		CALL CITP
		LCALL T1S
		LCALL T1S

		LJMP H34

H33:		JB NAHORU,H34		;
		CALL CITM
		LCALL T1S
		LCALL T1S

		LJMP H34

;-----------------------------STOP PROGRAMOVANI------------------------------------------------			
HOTOVO:	LCALL STOPP
		LCALL STOPP

		JMP $

;===========================================================================================================

;------------------------------PODPROGRAMY-------------------------------------------------
STOPP:
		LCALL TISK_I
		LCALL T05S
		LCALL T05S
		LCALL TISKNC
		LCALL T05S

		RET

LOCATE:;--------------------------UZAMKNUTI DO POLOHY H------------------------------------
		MOV 050H,#003H

LOCO:		MOV 051H,#004H
LOCO1:	LCAll TISKL
		LCALL T1S
		JNB NAHORU,L1		;TEST TLACITKA NAHORU
		LCAll TISKNC
		LCALL T1S
		JNB NAHORU,L1		;TEST TLACITKA NAHORU
		DJNZ 051H,LOCO1

		MOV 051H,#004H
LOCO2:	LCAll TISK0
		LCALL T1S
		JNB NAHORU,L1		;TEST TLACITKA NAHORU
		LCAll TISKNC
		LCALL T1S
		JNB NAHORU,L1		;TEST TLACITKA NAHORU
		DJNZ 051H,LOCO2

		MOV 051H,#004H
LOCO3:	LCAll TISKC
		LCALL T1S
		JNB NAHORU,L1		;TEST TLACITKA NAHORU
		LCAll TISKNC
		LCALL T1S
		JNB NAHORU,L1		;TEST TLACITKA NAHORU
		DJNZ 051H,LOCO3

	
		DJNZ 050H,LOCO
		LJMP LLL			;SKOK NA PARAMETR L

L1:		LCALL TISKH
		MOV addr_lo,#020H		;CTENI DATA 	
		MOV addr_hi,#000H
		MOV A,#000H
		LCALL read_random
		MOV 040H,A
		LCALL POLOHA

		LCALL STOPP
		LCALL STOPP

		JMP $

;-------------------------------------------------------------------------------------
		
T05S:		;------------------CASOVANI 0,5S--------------------------------------------
		LCALL T1S
		LCALL T1S
		LCALL T1S
		LCALL T1S


		RET
;------------------------------CITAC NASTAVENI KONSTANTY PRO CASOVANI +1----------------
CITP:		INC 042H
		MOV A,042H
		CJNE A,#010H,CITP1	;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		MOV 042H,#000H

CITP1:	CALL PREVOD

		MOV addr_lo,#030H		;WRITE DATA M42
		MOV addr_hi,#000H
		MOV ZDATA,042H	
		MOV A,#000H
		LCALL write_byte
		LCALL mikroS

		RET
;------------------------------CITAC NASTAVENI KONSTANTY PRO CASOVANI -1----------------
CITM:		DEC 042H
		MOV A,042H
		CJNE A,#0FFH,CITM1	;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		MOV 042H,#00FH

CITM1:	CALL PREVOD

		MOV addr_lo,#030H		;WRITE DATA M42
		MOV addr_hi,#000H
		MOV ZDATA,042H	
		MOV A,#000H
		LCALL write_byte
		LCALL mikroS

		RET
;---------------------------------------------------------------------------------------
PREVOD:	MOV A,042H		;----- M42 REGISTR CASU..........PREVOD A TISK HODNOTY----

		CJNE A,#000H,PR1		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISK0
		RET

PR1:		CJNE A,#001H,PX2		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISK1
		RET

PX2:		CJNE A,#002H,PX3		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISK2
		RET

PX3:		CJNE A,#003H,PX4		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISK3
		RET

PX4:		CJNE A,#004H,PX5		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISK4
		RET

PX5:		CJNE A,#005H,PX6		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISK5
		RET

PX6:		CJNE A,#006H,PX7		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISK6
		RET

PX7:		CJNE A,#007H,PX8		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISK7
		RET

PX8:		CJNE A,#008H,PX9		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISK8
		RET

PX9:		CJNE A,#009H,PXA		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISK9
		RET

PXA:		CJNE A,#00AH,PXB		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISKA
		RET

PXB:		CJNE A,#00BH,PXC		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISKB
		RET

PXC:		CJNE A,#00CH,PXD		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISKC
		RET

PXD:		CJNE A,#00DH,PXE		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISKD
		RET

PXE:		CJNE A,#00EH,PXF		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISKE
		RET

PXF:		CJNE A,#00FH,P100		;COMPARE  A s DATA = 33H  AND JUMP IF NOT EGUAL
		LCALL TISKF
		RET

P100:		RET


;---------------------------------------------------------------------------------------
;		    DECG FAB		SEGMENTY	
TISK0:	   ;00011000B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPC
	CLR DPF
	CLR DPA
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISK1:	  ;11011110B
	MOV LQD,#0FFH
	CLR DPC
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISK2:	  ;00101100B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPG
	CLR DPA
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISK3:	  ;01001100B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPC
	CLR DPG
	CLR DPA
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISK4:	  ;11001011B
	MOV LQD,#0FFH
	CLR DPC
	CLR DPG
	CLR DPF
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISK5:	  ;01001001B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPC
	CLR DPG
	CLR DPF
	CLR DPA
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISK6:	  ;00001001B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPC
	CLR DPG
	CLR DPF
	CLR DPA
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISK7:	  ;11011100B
	MOV LQD,#0FFH
	CLR DPC
	CLR DPA
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISK8:	  ;00001000B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPC
	CLR DPG
	CLR DPF
	CLR DPA
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISK9:	  ;01001000B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPC
	CLR DPG
	CLR DPF
	CLR DPA
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKA:	  ;10001000B
	MOV LQD,#0FFH
	CLR DPE
	CLR DPC
	CLR DPG
	CLR DPF
	CLR DPA
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKB:	  ;00001011B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPC
	CLR DPG
	CLR DPF
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKC:	  ;00111001B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPF
	CLR DPA
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKD:	  ;00001110B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPC
	CLR DPG
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKE:	  ;00101001B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPG
	CLR DPF
	CLR DPA
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKF:	  ;10101001B
	MOV LQD,#0FFH
	CLR DPE
	CLR DPG
	CLR DPF
	CLR DPA
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKL:	  ;00111011B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPF
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKH:	  ;10001010B
	MOV LQD,#0FFH
	CLR DPE
	CLR DPC
	CLR DPG
	CLR DPF
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKT: 	  ;00101011B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPG
	CLR DPF
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKS:	  ;01001001B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPC
	CLR DPG
	CLR DPF
	CLR DPA
	RET
;----------------------------------------------------------------------------------------
;		    DECG FAB		SEGMENTY	
TISKNC:	   ;11111111B
	MOV LQD,#0FFH
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKU:	  ;00011010B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPC
	CLR DPF
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		   DECG FAB		SEGMENTY	
TISKJ:	  ;00011110B
	MOV LQD,#0FFH
	CLR DPD
	CLR DPE
	CLR DPC
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;		    DECG FAB		SEGMENTY	
TISK_I:	   ;11001110B
	MOV LQD,#0FFH
	CLR DPC
	CLR DPG
	CLR DPB
	RET
;----------------------------------------------------------------------------------------
;	         DECG FAB		SEGMENTY	
TISKP:	  ;10101000B
	MOV LQD,#0FFH
	CLR DPE
	CLR DPG
	CLR DPF
	CLR DPA
	CLR DPB
	RET
;----------------------------------------------------------------------------------------


STRED:				;NAJETI NA STRED
	MOV R7,#DOBA_AKCE		
X3:	SETB RELE
	MOV R6,#040H
	MOV 040H,R6		;R6>M(ADR=00H)

X4:	LCALL T10us
	DJNZ R6,X4	
	CLR RELE
	LCALL T100ms
	DJNZ R7,X3

	RET	
;--------------------------------------------------------------------------------------

KRL:			;KROK VLEVO
	DEC 40H

	MOV R7,#DOBA_KROKU	
X9:	SETB RELE
	MOV R6,040H
X10:	LCALL T10us
	DJNZ R6,X10	
	CLR RELE
	LCALL T100ms
	DJNZ R7,X9

	RET
;--------------------------------------------------------------------------------------
POLOHA:				;NAJETI  DO POLOHY DLE M40 
	MOV R7,#DOBA_AKCE		
X5:	SETB RELE
	MOV R6,040H
X6:	LCALL T10us
	DJNZ R6,X6	
	CLR RELE
	LCALL T100ms
	DJNZ R7,X5

	RET	
;--------------------------------------------------------------------------------------
KRR:			;KROK VPRAVO
	INC 40H

	MOV R7,#DOBA_KROKU	
X12:	SETB RELE
	MOV R6,040H
X11:	LCALL T10us
	DJNZ R6,X11	
	CLR RELE
	LCALL T100ms
	DJNZ R7,X12

	RET
	
;-------------------------------------------- TIME INTERVAL 10ms --------------------19991
T10ms:
	MOV TL0,#0E8H;
	MOV TH0,#0B1H;
	SETB TR0;
	JNB TF0,$;
	CLR TR0;
	CLR TF0;
	RET;


;----------------- TIME INTERVAL 100ms ---------------------
T100ms:
	MOV R0,#00AH	;K=#00AH>R0
N1:	LCALL T10ms
	JB 098H,N11		;IF BIT(ADR=98H)=1.....PRIZNAK PRIJMU PRIJIMACE Rx 
	DJNZ R0,N1		;DECREMENT AND JUMP IF NOT ZERO
N11:	RET
;----------------- TIME INTERVAL 1s ------------------------
T1s:
	MOV R1,#004H	;K=#00AH>R0
N2:	LCALL T100ms
	JB 098H,N21		;IF BIT(ADR=98H)=1.....PRIZNAK PRIJMU PRIJIMACE Rx 
	DJNZ R1,N2		;DECREMENT AND JUMP IF NOT ZERO
N21:	RET
;----------------- TIME INTERVAL 3s ------------------------
T3s:
	MOV R2,#008H	;K=#003H>R0
N3:	LCALL T1s
	JB 098H,N31		;IF BIT(ADR=98H)=1.....PRIZNAK PRIJMU PRIJIMACE Rx 
	DJNZ R2,N3		;DECREMENT AND JUMP IF NOT ZERO
N31:	RET

;----------------- TIME INTERVAL 6us -----------------PODPROGRAMY
T10us:
	;2 CYCLES ....delta T=12/24000000=0.5xE-6=0.5us
	MOV TL0,#0FFH; 		Q=24MHz (1C) FF,FE,FD,FC,FB,FA,F9,F8,F7,F6,F5,F4 ...>>> 12x0.5us...>>>12x0,5=6us
	MOV TH0,#0FFH;                                                 --->>A PRO 22,1904MHz-12x5,40774388=6,4829us
	SETB TR0; 		START (1C........0.5us
	JNB TF0,$; 		JUMP SELF vlastni....2x0.5us
	CLR TR0; 		STOP (1C)........2x0.5us
	CLR TF0;		CLEAR FLAG (1C)....2x0.5us 	
	RET; 			(2C)...........0.5us

;----------------------------------------------------------------------------
T100us:				
	MOV TL0,#040H; 		
	MOV TH0,#0FFH;
	SETB TR0; 		
	JNB TF0,$; 		 
	CLR TR0; 		
	CLR TF0;		 	
	RET; 			
;----------------- TIME INTERVAL 1ms -------------------1991=19991/10-8
T1ms:	
	MOV TL0,#038H;....FFFFH=65535D.....F838=63544....FFFF-F838=7C7=1991D.....1991x0,5us=995,5us...MUSI SE PRIPOCITAT 12x0,5us STROJ CAS
	MOV TH0,#0F8H;
	SETB TR0;
	JNB TF0,$;
	CLR TR0;
	CLR TF0;
	RET;
;----------------- TIME INTERVAL 1,25ms -------------------1991=19991/10-8
T1ms25:
	MOV TL0,#045H;....995,5us+250us=1245us....1245/0.5=2490D=9BAH.....FFFF-9BA=F645H=2490D
	MOV TH0,#0F6H;
	SETB TR0;
	JNB TF0,$;
	CLR TR0;
	CLR TF0;
	RET;

;================================== SRAM PODPROGRAMY ==================================================================



write_byte:

	; AT24Cxx Byte Write function.
	; Called with programmable address in A, byte address in
	; register pair ADDR_HI:ADDR_LO, data in register XDATA.
	; Does not wait for write cycle to complete.
	; Returns CY set to indicate that the bus is not available
	; or that the addressed device failed to acknowledge.
	; Destroys A.

		call	start
		jc	x49		; abort if bus not available

		rl	a		; programmable address to bits 3:1
		orl	a, #FADDR	; add fixed address
		clr	acc.0		; specify write operation
		call	shout		; send device address
		jc	x48		; abort if no acknowledge

		mov	a, addr_hi	; send high byte of address
		call	shout		;
		jc	x48		; abort if no acknowledge

		mov	a, addr_lo	; send low byte of address
		call	shout		;
		jc	x48		; abort if no acknowledge

		mov	a, zdata	; get data
		call	shout		; send data
		jc	x48		; abort if no acknowledge

		clr	c		; clear error flag
	x48:
		call	stop
	x49:
		ret


read_current:

	; AT24Cxx Current Address Read function.
	; Called with programmable address in A. Returns data in A.
	; Returns CY set to indicate that the bus is not available
	; or that the addressed device failed to acknowledge.

		call	start
		jc	x45		; abort if bus not available

		rl	a		; programmable address to bits 3:1
		orl	a, #FADDR	; add fixed address
		setb	acc.0		; specify read operation
		call	shout		; send device address
		jc	x44		; abort if no acknowledge

		call	shin		; receive data byte
		call	NAK		; do not acknowledge byte
		clr	c		; clear error flag
	x44:
		call	stop
	x45:
		ret


read_random:

	; AT24Cxx Random Read function.
	; Called with programmable address in A, byte address in
	; register pair ADDR_HI:ADDR_LO. Returns data in A.
	; Returns CY set to indicate that the bus is not available
	; or that the addressed device failed to acknowledge.

		push	b
		mov	b, a		; save copy of programmable address

		; Send dummy write command to set internal address.

		call	start
		jc	x47		; abort if bus not available

		rl	a		; programmable address to bits 3:1
		orl	a, #FADDR	; add fixed address
		clr	acc.0		; specify write operation
		call	shout		; send device address
		jc	x46		; abort if no acknowledge

		mov	a, addr_hi	; send high byte of address
		call	shout		;
		jc	x46		; abort if no acknowledge

		mov	a, addr_lo	; send low byte of address
		call	shout		;
		jc	x46		; abort if no acknowledge

		; Call Current Address Read function.

		mov	a, b		; get programmable address
		call	read_current
		jmp	x47		; exit
	x46:
		call	stop
	x47:
		pop	b
		ret


start:

	; Send START, defined as high-to-low SDA with SCL high.
	; Return with SCL, SDA low.
	; Returns CY set if bus is not available.

		setb	SDA
		setb	SCL

		; Verify bus available.

		jnb	SDA, x40	; jump if not high
		jnb	SCL, x40	; jump if not high

		nop			; enforce setup delay and cycle delay
		clr	SDA
		nop			; enforce hold delay
		nop			;
		nop			;
		nop			;
		nop			;
		clr	SCL

		clr	c		; clear error flag
		jmp	x41
	x40:
		setb	c		; set error flag
	x41:
		ret


stop:

	; Send STOP, defined as low-to-high SDA with SCL high.
	; SCL expected low on entry. Return with SCL, SDA high.

		clr	SDA
		nop			; enforce SCL low and data setup
		nop
		setb	SCL
		nop			; enforce setup delay
		nop			;
		nop			;
		nop			;
		nop			;
		setb	SDA
		ret


shout:

	; Shift out a byte to the AT24Cxx, most significant bit first.
	; SCL, SDA expected low on entry. Return with SCL low.
	; Called with data to send in A.
	; Returns CY set to indicate failure by slave to acknowledge.
	; Destroys A.

		push	b
		mov	b, #8		; bit counter
	x42:
		rlc	a		; move bit into CY
		mov	SDA, c		; output bit
		nop			; enforce SCL low and data setup
		setb	SCL		; raise clock
		nop			; enforce SCL high
		nop			;
		nop			;
		nop			;
		clr	SCL		; drop clock
		djnz	b, x42		; next bit

		setb	SDA		; release SDA for ACK
		nop			; enforce SCL low and tAA
		nop			;
		setb	SCL		; raise ACK clock
		nop			; enforce SCL high
		nop			;
		nop			;
		nop			;
		mov	c, SDA		; get ACK bit
		clr	SCL		; drop ACK clock

		pop	b
		ret


shin:

	; Shift in a byte from the AT24Cxx, most significant bit first.
	; SCL expected low on entry. Return with SCL low.
	; Returns received data byte in A.

		setb	SDA		; make SDA an input

		push	b
		mov	b, #8		; bit count
	x43:
		nop			; enforce SCL low and data setup
		nop			;
		nop			;
		setb	SCL		; raise clock
		nop			; enforce SCL high
		nop			;
		mov	c, SDA		; input bit
		rlc	a		; move bit into byte
		clr	SCL		; drop clock
		djnz	b, x43		; next bit

		pop	b
		ret


ACK:

	; Clock out an acknowledge bit (low).
	; SCL expected low on entry. Return with SCL, SDA low.

		clr	SDA		; ACK bit
		nop			; enforce SCL low and data setup
		nop			;
		setb	SCL		; raise clock
		nop			; enforce SCL high
		nop			;
		nop			;
		nop			;
		clr	SCL		; drop clock
		ret


NAK:

	; Clock out a negative acknowledge bit (high).
	; SCL expected low on entry. Return with SCL low, SDA high.

		setb	SDA		; NAK bit
		nop			; enforce SCL low and data setup
		nop			;
		setb	SCL		; raise clock
		nop			; enforce SCL high
		nop			;
		nop			;
		nop			;
		clr	SCL		; drop clock
		ret

;========================MOJE ZPOZDENI =============================
mikroS:	
		MOV R7,#0FFH		;pro 4MHz
		DJNZ R7,$
		MOV R7,#0FFH		;pro 4MHz
		DJNZ R7,$
		MOV R7,#0FFH		;pro 4MHz
		DJNZ R7,$

		RET
;------------------------------------------VAROVANI------------------------------------------------------------
VAROVANI:
		LCALL TISK2
		LCALL T05S

		LCALL TISKA
		LCALL T05S

		LCALL TISKD
		LCALL T05S

		LCALL TISKE
		LCALL T05S

		LCALL TISKJ
		LCALL T05S

		LCALL TISKC
		LCALL T05S

		LCALL TISK0
		LCALL T05S

		LCALL TISKD
		LCALL T05S

		LCALL TISKE
		LCALL T05S

		LCALL TISKNC
		LCALL T05S
		LCALL T05S
		LCALL T05S
		LCALL T05S
		LCALL T05S
		LCALL T05S
		LCALL T05S
		LCALL T05S

		LJMP VAROVANI


;----------------------------------------------------------------------------------------------------------

READY1:	DB	'                                                                                  ',0
READY2:	DB	' TENTO PROGRAM JE AUTORSKY CHRANEN JEHO TVURCEM A JAKEKOLIV ZMENY',0
READY3:	DB	' V PROGRAMU SE NEDOPORUCUJI Z DUVODU BEZPECNOSTI CELEHO ZARIZENI.',0
READY4:	DB	' PROGRAM JE VLASTNICTVIM SVEHO TVURCE.',0

	
	END
	

